// Basic Patcher, Carwyn Jones ©(2002)

#include <fstream>
#include <string.h>

int FilePatch(const char *file);

int main(int argc, char *argv[])
{
	if(argc != 2) {
		cout << argv[0] << " <file to patch>" << endl;
		return(true);
	}
	FilePatch(argv[1]);
	return(0);
}

int FilePatch(const char *file)
{
	fstream fin;
	char buf[13];
	unsigned long j;
	char origid[] = "GenuineIntel";
	char newid[] = "AuthenticAMD";
	
	fin.open(file, ios::in | ios::out | ios::binary);
	if(!fin) {
		cout << "Can't open: " << file << " for reading" << endl;
		return(true);
	}
	
	fin.seekg(0, ios::end);
	j = fin.tellg();
	fin.seekg(ios::beg);
	
	if(j < 0x1627451f) { // arbitary file size check
		cout << "error: Your BeOS personal edition image is not the correct size, Patch failed !" << endl;
		fin.close();
		return(true);
	}
	
	cout << "Trying to patch your BeOS personal edition image" << endl;
	fin.seekg(0x16274513);
	fin.read(buf, 12);
	
	if(!strncmp(origid, buf, 12) == 0) {
		cout << "error: GenuineIntel cannot be found, Patch failed !" << endl;
		return(true);
		
	}
	
	cout << "The following string has been found: " << buf << endl;
	cout << "Changing the string to AuthenticAMD" << endl;
	
	fin.seekg(fin.tellg()-12);
	
	fin.write(newid, 12);
	cout << "Patch successful, please test before getting too excited, :-/" << endl;
	fin.close();
	return(0);
}